VS NDK Güncellemeleri

Tekrar merhaba arkadaşlar. Bu sefer kısa bir hatırlatma ve sizleri bir zahmetten kurtaracağını düşündüğüm bir husustan bahsedeceğim 🙂

VS 2017 ile C/C++ Kütüphanelerin (SDL) Android için Oluşturulması

yazımdan hatırlayacağınız üzere çoklu platformlar için VS ile yazılım geliştirmede kullandığımız SDL’i hem android hem Windows için nasıl oluşturabileceğimiz görmüştük. O yazımızda VS henüz NDK15c ve Clang 5.0 kullanmıyordu. Her neyse benzer şekilde SFML’i de oluşturma ihtiyacı hasıl oldu ve SDL için izlediğimiz adımları izleyerek VS de ilgili projeleri oluşturmaya başladım. Kütüphaneleri oluşturmada herhangi bir problem ile karşılaşmadım ta ki kaynak kod ile gelen örnek uygulamayı oluşturana kadar.

SFML şu an resmi olarak Android’i desteklemiyor ama açıkçası daha önceden ilgili “Graphics” kütüphanesini SDL aracılığı ile Android’te kullanmıştım. Gel gelelim başka bir uygulamam için SFML’i direk kullanmak istedim ve bunun için de bu örnek uygulamayı derleme yoluna gittim. İlk farklılığı oluşturma aracında fark ettim, örnek uygulama Gradle aracını kullanıyordu ve açıkçası daha önce NDK için bunu kullanmamıştım (Gradle nedir ne eder konusu ayrı bir mevzu ama kısaca Ant ve Maven‘a bir alternatif diyebiliriz). SDL için de Ant‘ı kullanmıştım. Neyse Gradle ile istediğimi alamayınca hemen daha önce SDL için oluşturduğum Ant tabanlı bir “Native-Activity Application (Android)” projesi VS de oluşturup, örnek uygulamayı bunun aracılığı ile paketlemeyi planladım. Gel gelelim ki bir türlü paketleme işlemini Ant ile başaramadım. Aşağıdaki gibi bir hata alıyordum:

Açıkçası google ile biraz didindikten sonra hemen daha önce hazırladığım SDL örneğine döndüm ve onu paketlemeyi denedim. Ta ta! Ne yazık ki aynı sıkıntıyı orada da yaşadım. Sonrasında biraz daha google ile cebelleştikten sonra sorunun kaynağına ulaştım. Google Android SDK 25.3.0 Tools ile birlikte artık eski ant betiklerinin bir kısmını SDK’den kaldırmış (yani adam Gradle kullanın diyor) bu sebeple de VS veya komut satırında NDK projelerini oluşturmaya kalktığınız böyle bir problem ile karşılaşıyorsunuz.

https://developer.android.com/studio/releases/sdk-tools.html SDK Tools, Revision 25.3.0 (March 2017):

“Changes:

  • Obsolete/deprecated tools have been removed:
    • android
    • ddms (instead see Using DDMS)
    • draw9patch (instead see Draw 9-patch)
    • hierarchyviewer (instead see Profile Your Layout with Hierarchy Viewer)
    • traceview (instead see Profiling with Traceview and dmtracedump)
    • ant scripts
    • Project and activity templates”

Gelelim çözüme. Önünüzde iki seçenek var:
1) Aşağıda verdiğim sitelerden geliştirme platformunuza göre ilgili araç dizinlerini indirip Android SDK Tool dizini (varsayılan konumu C:\ProgramData\Microsoft\AndroidSDK\25\tools) ile yer değiştirebilirsiniz,

2) Ya da uygulamanızın paketlemesini Gradle kullanacak şekilde güncellersiniz.  Açıkçası bu önerilen yöntem ve gördüğüm kadarı SFML dahil bir çok proje bu yönde devam ediyor. Açıkçası ben Gradle’ı henüz çok detaylı bilmiyorum ve aslında sadece bir kaç hususu denemek istiyorum bunun için ben ilk yöntemi takip ettim. Muhtemelen VS de bu tarz kullanımları düşünerek halen Ant tabanlı Android proje oluşturma şablonlarını koruyor.

Gelelim sadede. Araçlar ve kütüphanelerin (özellikle açık kaynaklı olanların ama aslında her durumda) yeni sürümlerini kullanmadan önce muhakkak değişiklikleri inceleyin 🙂 Bu arada yeni yazımız için de bir aday ortaya çıkmış oldu: “Oluşturma Araçları”. Bakalım vakit bulabilirsem bir sonraki yazılarımdan birini buna ayırmayı planlıyorum.

Tekrar görüşmek üzere sevgili yazılımperver dostlarım.

Bir cevap yazın

E-posta hesabınız yayımlanmayacak. Gerekli alanlar * ile işaretlenmişlerdir

This site uses Akismet to reduce spam. Learn how your comment data is processed.